#include <stdio.h>
#include "nSystem.h"

typedef struct Sem {
  int tickets;
  nMonitor ctrl;
} Sem;


Sem* make_sem(int tickets){
    Sem *sem = (Sem *) nMalloc(sizeof(Sem));
    sem->tickets = tickets;
    sem->ctrl = nMakeMonitor();
    return sem;
}

void wait_sem(Sem* sem){
    nEnter(sem->ctrl);
    while(sem->tickets == 0)
      nWait(sem->ctrl);
    sem->tickets--;
    nNotifyAll(sem->ctrl);
    nExit(sem->ctrl);
}

void signal_sem(Sem* sem){
    nEnter(sem->ctrl);
    sem->tickets++;
    nNotifyAll(sem->ctrl);
    nExit(sem->ctrl);
}


Sem* s;
int escritor(int num);

nMain(){
    srand(time(0));
    s = make_sem(2);
    nTask t[10];
    int i;
    for(i=0; i<10; ++i){
        t[i] = nEmitTask(escritor, i);
    }
    for(i=0; i<10; ++i){
        nWaitTask(t[i]);
    }
}

int escritor(int num){
    int i;
    for(i=0; i<1; ++i){
        int milis = 500 + (rand() % 1000);
        wait_sem(s);
        nPrintf("tarea %i inicio escritura... duerme por %d\n", num, milis);
        nSleep(milis);
        nPrintf("tarea %i fin escritura\n", num);
        signal_sem(s);
	}
}
